#include <AppKit/AppKit.h>

static NSString *NSMenuLocationsKey = @"NSMenuLocations";
@interface NSMenu(private)
- (NSString *)_locationKey;
@end

@implementation NSMenu (MenuGoAway)
- (void) _updateUserDefaults:(id)notif
{
  /* don't write NSMenuLocations */
}

- (void) setGeometry
{
  NSString       *key;
  NSPoint        origin;

  if (nil != (key = [self _locationKey]))
    {
      NSUserDefaults *defaults;
      NSDictionary   *menuLocations;
      NSString       *location;

      defaults = [NSUserDefaults standardUserDefaults];
      menuLocations = [defaults objectForKey: NSMenuLocationsKey];

      if ([menuLocations isKindOfClass: [NSDictionary class]])
        location = [menuLocations objectForKey: key];
      else
        location = nil;

      if (location && [location isKindOfClass: [NSString class]])
        {
          [_aWindow setFrameFromString: location];
          [_bWindow setFrameFromString: location];
	  [_aWindow setFrameOrigin:NSMakePoint(0-[_aWindow frame].size.width, 0-[_aWindow frame].size.width)];
	  [_bWindow setFrameOrigin:NSMakePoint(0-[_bWindow frame].size.width, 0-[_bWindow frame].size.width)];
          return;
        }
    }

  origin = NSMakePoint(0-[_aWindow frame].size.width, 0-[_aWindow frame].size.height);

  [_aWindow setFrameOrigin: origin];
  [_bWindow setFrameOrigin: origin];
}

@end
